<template>
  <div id="app">
    <img
      alt="GitLab Logo"
      src="./assets/gitlab-logo-500.svg"
      class="logo gitlab"
    />

    <h1 class="heading mb-10">GitLab Experiments</h1>

    <div v-if="mode=='existing'">
      <ExistingWorkspace :existing="existing" :project="project" :gitRef="ref" />
    </div>
    <div v-if="mode=='provision'">
      <ProvisioningStatus :environment="environment" />
    </div>
    <div v-if="mode=='select-ide'">
      <SelectIDE :project="project" :gitRef="ref" :options="ides" :new-status="newStatus" />
    </div>
  </div>
</template>

<script>
import ExistingWorkspace from "./components/ExistingWorkspace.vue"
import ProvisioningStatus from "./components/ProvisioningStatus.vue";
import SelectIDE from "./components/SelectIDE.vue";

const params = new Proxy(new URLSearchParams(window.location.search), {
    get: (searchParams, prop) => searchParams.get(prop),
});

export default {
  components: {
    ExistingWorkspace,
    ProvisioningStatus,
    SelectIDE
  },
  mounted() {
    this.existing = params['existing']
    this.project = params['project']
    this.ref = params['ref']
    this.ides = []
    this.environment = params['environment']
    this.newStatus = params['new']

    if (this.existing) {
      this.mode = "existing"
    } else if (this.environment) {
      this.mode = "provision"
    } else if (params['ides']) {
      this.mode = "select-ide"
      this.ides = JSON.parse(params['ides'])
    }
  },
  data() {
    return {
      mode: "",
      existing: "",
      project: "",
      ref: "",
      environment: "",
      newStatus: "",
    }
  }
};
</script>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}

.logo {
  margin: auto;
  width: 300px;
}

.heading {
  font-size: 2rem;
}
</style>